/*                     __                                               *\
**     ________ ___   / /  ___      __ ____  Scala.js tools             **
**    / __/ __// _ | / /  / _ | __ / // __/  (c) 2013-2014, LAMP/EPFL   **
**  __\ \/ /__/ __ |/ /__/ __ |/_// /_\ \    http://scala-js.org/       **
** /____/\___/_/ |_/____/_/ | |__/ /____/                               **
**                          |/____/                                     **
\*                                                                      */


package scala.scalajs.tools.corelib

import java.io.File
import java.net.URI

import scala.io.Source

import scala.scalajs.ir.ScalaJSVersions
import scala.scalajs.tools.io._

import scala.collection.immutable.Seq

object CoreJSLibs {

  lazy val libs: Seq[VirtualJSFile] = {
    val libName = "scalajsenv.js"
    val publicURI =
      if (ScalaJSVersions.currentIsSnapshot) libName
      else githubToolsURI.resolve("scalajsenv.js")

    val lib = new MemVirtualJSFile(publicURI.toString)
      // ScalaJSEnvHolder is generated by sbt
      .withContent(ScalaJSEnvHolder.scalajsenv)
      .withVersion(Some("")) // it won't change

    Seq(lib)
  }

  private def githubToolsURI: URI = {
    val version = ScalaJSVersions.current
    new URI(s"https://raw.githubusercontent.com/scala-js/scala-js/v$version/"+
        "tools/")
  }

}
